unit uMapiStuff;

interface


uses
  Dialogs, Sysutils, ComObj, ActiveX, windows,
  MapiX, MapiCode, MapiTags, MapiDefs,
  MapiForm, MapiHook, MapiWz, MapiSpi, Imessage, Tnef;

type
  PNotificationsArray = ^TNotificationsArray;
  TNotificationsArray = array [0..MaxInt div SizeOf(TNotification) -1] of TNotification;

  PIMAPIAdviseSink = ^IMAPIAdviseSink;

  TMAPINotifyEvent = function(Sender:TObject; NumEntries: longint;
            Notifications :PNotificationsArray): longint; stdcall;


  TMAPIEvents = class(TObject)
   private
    FSession : IMAPISession;
    FSink:IMAPIAdviseSink;
    FCookie:integer;
   public
    constructor Create(NotifyHandler: TMAPINotifyEvent);
    destructor Destroy;override;
  end;

procedure HrAllocAdviseSink(Callback: pointer; Sender: pointer;
                            Sink: PIMAPIAdviseSink);  stdcall;
          external 'mapi32.Dll' name 'HrAllocAdviseSink@12';

implementation


constructor TMAPIEvents.Create(NotifyHandler: TMAPINotifyEvent);
var
  err: integer;

begin
  inherited create;
  if not assigned(NotifyHandler) then
  raise exception.create('Notify callback handler not defined (NotifyHandler)');
  err := MAPIInitialize(nil);
  OLEInitialize(nil);
  QueryDefaultMsgStore(
  if err = S_OK then
    begin
      err:= MAPILogonEx(0, nil, nil, MAPI_LOGON_UI or MAPI_EXTENDED, FSession);
      if err = S_OK then
        begin
          HrAllocAdviseSink(@NotifyHandler, Self, @FSink);
          err:= FSession.Advise(0,nil, fnevNewMail, FSink, FCookie);
        end;
    end;
end;


destructor TMAPIEvents.Destroy;
begin
  FSession.Unadvise(FCookie);
  FSession.Logoff(0, MAPI_LOGOFF_UI, 0);
  FSession:= nil;
  FSink:= nil;
  MAPIUninitialize;
end;

end.
 